/*!
 * fisappmessagejs V1.0.0
 * Copyright(c) 2020 Software Optima Sdn. Bhd.
 */

/**
 * Fis message parameter.
 * Information required for message integration with Fis back office.
 * 
 * @interface FisMessageParameter 
 */
export interface FisMessageParameter {
    /**
     * Fis service instance id.
     * A FisApp generated reference ID to an instantiated service in Fis 
     * Back office server. Can be null if not applicable.
     * 
     * @interface FisMessageParameter
     * @property instanceId
     * @type {string}
     */
    instanceId: string;

    /**
     * Fis service to invoke(mandatory).
     * 
     * @interface FisMessageParameter
     * @property serviceId
     * @type {string}
     */
    serviceId: string;

    /**
     * Fis user id.
     * 
     * @interface FisMessageParameter
     * @property userId
     * @type {string}
     */
    userId: string;

    /**
     * Fis data source timing. i.e. EDIT(get data from editing cache).
     * 
     * @interface FisMessageParameter
     * @property dataSourceTiming
     * @type {string}
     */
    dataSourceTiming: string;
}
